#set-env BAT_THEME Coldark-Cold
set-env BAT_PAGER 'less -RF'
set-env EDITOR vim
set-env VIEW 'vim -R'
set-env CURRENT_SHELL 'elvish'
set-env STARSHIP_CONFIG ~/.config/starship/starship.toml
set-env PERL5LIB /home/benjamin/perl5/lib/perl5
set @paths = $@paths /home/benjamin/bin /home/benjamin/Go/bin /home/benjamin/perl5/bin

{
  use framagit.org/benjamin.vaudour/elv-lib/mods/list
  if (list:contains-not /usr/local/bin $paths) {
    set @paths = $@paths /usr/local/bin
  }
}

set notify-bg-job-success = $false

set edit:insert:binding[Tab]            = { edit:completion:smart-start; edit:navigation:trigger-filter }
set edit:insert:binding[Ctrl-H]         = $edit:histlist:start~
set edit:insert:binding[Ctrl-F]         = $edit:move-dot-right~
set edit:insert:binding[Ctrl-B]         = $edit:move-dot-left~
set edit:insert:binding[Ctrl-E]         = $edit:move-dot-eol~
set edit:insert:binding[Ctrl-A]         = $edit:move-dot-sol~
set edit:insert:binding[Alt-B]          = $edit:move-dot-left-word~
set edit:insert:binding[Alt-F]          = $edit:move-dot-right-word~
set edit:insert:binding[Alt-T]          = $edit:transpose-word~
set edit:insert:binding[Ctrl-T]         = $edit:transpose-rune~
set edit:insert:binding[Ctrl-P]         = $edit:history:start~
set edit:insert:binding[Alt-Delete]     = $edit:kill-word-right~
set edit:insert:binding[Alt-Backspace]  = $edit:kill-word-left~
set edit:history:binding[Ctrl-P]        = $edit:history:up~
set edit:insert:binding[Ctrl-N]         = $edit:history:start~
set edit:history:binding[Ctrl-N]        = $edit:history:down-or-quit~

#set edit:prompt  = { go-prompt }
#set edit:rprompt = { nop }

# Starship prompt : https://starship.rs/
#eval (starship init elvish)
eval (starship init elvish --print-full-init | sed 's/except/catch/' | slurp)

# Carapace completion : https://github.com/rsteube/carapace-bin
eval (carapace _carapace|slurp)

# Initialisation des aliases et de l’autocomplétion
use framagit.org/benjamin.vaudour/elv-lib/alias
use framagit.org/benjamin.vaudour/elv-lib/completion

# On ajoute les modules natifs que j’utilise beaucoup
use math
use str
use re
#use framagit.org/benjamin.vaudour/elv-lib/mods/format
#use framagit.org/benjamin.vaudour/elv-lib/mods/list
#use framagit.org/benjamin.vaudour/elv-lib/mods/map

{
  use ./aliases/get-uid uid
  if (not (uid:-is-root)) {
    tache search -d 2w not del
  }
}
